(function ($) {

    AJS.toInit(function () {

        var showAll = function () {
                var groupsContainer = $("#settings-groups-list");
                groupsContainer.html("");
                $.ajax({
                    type: "GET",
                    contentType: "application/json; charset=utf-8",
                    url: AJS.contextPath() + "/rest/noemailstorm/1.0/show"
                }).done(function (response) {
                        var result = JSON.stringify(response);
                        var result = JSON.parse(result);
                        for (var i = 0; i < result.settings.length; ++i) {
                            var groupName = result.settings[i];
                            var groupsItem = $("<tr />");
                            groupsItem.append('<td>' + groupName + '</td>');
                            groupsItem.append('<td><a href="#delete" group-id="' + groupName.replace('"', '&quot;') + '" class="delete-link">Delete</a></td>');
                            groupsContainer.append(groupsItem);
                        }
                    }).fail(function () {
                        clearMessages();
                        AJS.messages.error("#aui-message-bar", {
                            title: "Failed to show settings.",
                            body: "<p>See log for details.</p>"
                        });
                    });
            },

            deleteGroup = function (groupName) {
                $.ajax({
                    type: 'GET',
                    url: AJS.contextPath() + '/rest/noemailstorm/1.0/delete',
                    contentType: 'application/json; charset=utf-8',
                    data: {
                        'groupName': groupName
                    },
                    dataType: "text"
                }).done(function () {
                        clearMessages();
                        showAll();
                    }).fail(function () {
                        clearMessages();
                        AJS.messages.error("#aui-message-bar", {
                            title: "Failed to delete group from settings.",
                            body: "<p>See log for details.</p>"
                        });
                    });
            },

            addGroup = function () {
                $.ajax({
                    type: 'GET',
                    url: AJS.contextPath() + '/rest/noemailstorm/1.0/add',
                    contentType: 'application/json; charset=utf-8',
                    data: {
                        'groupName': $("#no_email_storm_group").val()
                    },
                    dataType: "text"
                }).done(function () {
                        clearMessages();
                        showAll();
                    }).fail(function () {
                        clearMessages();
                        AJS.messages.error("#aui-message-bar", {
                            title: "Failed to add group to settings.",
                            body: "<p>See log for details.</p>"
                        });
                    });
            },

            clearMessages = function () {
                $("#aui-message-bar").empty();
            };

        $(".delete-link").live("click", function (e) {
            var groupName = $(e.target).attr('group-id');
            deleteGroup(groupName);
        });

        $("#add-group-form").submit(function (e) {
            e.preventDefault();
            addGroup();
            $("#no_email_storm_group").val("");
        });

        showAll();
    });
})(AJS.$);